Program idxndat;
{$APPTYPE CONSOLE}
Uses SysUtils;
Var
    Sz, TF, I, FOffs, FSize: LongInt;
             Fidx, Fdat, Fl: File;
                          P: Pointer;
                          S: String;
Begin
  WriteLn('Rome: Total War .IDX + .DAT file extractor (music, voices and sound ONLY!)');
  WriteLn('You can find it in: \Rome - Total War\Data\sounds');
  WriteLn('T#i$ PR0GR@M bY -=CHE@TER=-');
  WriteLn('HTTP://CTPAX-CHEATER.narod.RU');
  WriteLn;
  If ParamCount<>1 Then
    Begin
      WriteLn('Usage: idxndat filename.<idx|dat>');
      WriteLn;
      Exit;
    End;

  S:=Copy(ParamStr(1), 1, Length(ParamStr(1)) - 3) + 'idx';
  If Not FileExists(S) Then
    Begin
      WriteLn('Error: index file "', S, '" not exists!');
      Exit;
    End;
  AssignFile(Fidx, S);
  Reset(Fidx, 1);

  S:=Copy(ParamStr(1), 1, Length(ParamStr(1)) - 3) + 'dat';
  If Not FileExists(S) Then
    Begin
      WriteLn('Error: data file "', S, '" not exists!');
      CloseFile(Fidx);
      Exit;
    End;
  AssignFile(Fdat, S);
  Reset(Fdat, 1);

  SetLength(S, 8);
  BlockRead(Fidx, S[1], 8);
  BlockRead(Fdat, S[1], 8);
  If S<>'SND.PACK' Then
    Begin
      WriteLn('Sorry, this program can extract ONLY "SND.PACK" signatured files.');
      WriteLn('Because "ENV.PACK" archives don''t have file names at all.');
      CloseFile(Fidx);
      CloseFile(Fdat);
      Exit;
    End;
  BlockRead(Fidx, Sz, 4); { $04 }
  BlockRead(Fdat, Sz, 4); { $04 }
  BlockRead(Fidx, TF, 4); { Total Files }
  BlockRead(Fdat, Sz, 4); { Total Files }
  If TF<>Sz Then
    Begin
      WriteLn('Different file counter in data and index file!');
      CloseFile(Fidx);
      CloseFile(Fdat);
      Exit; { Must be equal! }
    End;
  BlockRead(Fidx, Sz, 4); { File start in .dat file?.. }
  BlockRead(Fdat, I, 4); { File start in .dat file?.. }
  If I<>Sz Then { Must be equal! }
    Begin
      WriteLn('Different start offset in data and index file!');
      CloseFile(Fidx);
      CloseFile(Fdat);
      Exit; { Must be equal! }
    End;
  BlockRead(Fidx, Sz, 4); { Key?.. }
  BlockRead(Fdat, I, 4); { Key?.. }
  If I<>Sz Then { Must be equal! }
    Begin
      WriteLn('Different key in data and index file!');
      CloseFile(Fidx);
      CloseFile(Fdat);
      Exit; { Must be equal! }
    End;
  For I:=1 To TF Do
    Begin
      BlockRead(Fidx, FOffs, 4); { File offset }
      BlockRead(Fidx, FSize, 4); { File size }
      Seek(Fidx, FilePos(Fidx) + 12);
      BlockRead(Fidx, Sz, 4); { $0D --- ? }
      SetLength(S, 0);
      Repeat
        Sz:=Length(S) + 1;
        SetLength(S, Sz);
        BlockRead(Fidx, S[Sz], 1);
      Until S[Sz] = #0;
      SetLength(S, Sz - 1);
      WriteLn(S);
      GetMem(P, FSize);
      Seek(Fdat, FOffs);
      BlockRead(Fdat, P^, FSize);
      While Pos('/', S)<>0 Do
        Begin
          Sz:=Pos('/', S);
          If Sz <> 0 Then S[Sz]:=#0;
          If Not DirectoryExists('.\' + PChar(S)) Then MkDir('.\' + PChar(S));
          If Sz <> 0 Then S[Sz]:='\';
        End;
      AssignFile(Fl, '.\' + S);
      ReWrite(Fl, 1);
      BlockWrite(Fl, P^, FSize);
      CloseFile(Fl);
      FreeMem(P, FSize);

      SetLength(S, 3);
      BlockRead(Fidx, S[1], 3); { $CD CD CD --- ? }
    End;
  CloseFile(Fdat);
  CloseFile(Fidx);
  WriteLn('Total files: ', TF);
  WriteLn('Done.');
End.
